package jp.ac.shibaura_it.ma15082;

import org.aiwolf.client.lib.Content;
import org.aiwolf.common.data.Species;

public enum Colour {
	WHITE(""),
	BLACK(""),
	GREY("D"),
	PANDA("p_"),
	NONE("")
	;
	
	private String name;
	private Colour(final String s){
		name=s;
	}
	
	public String getName(){
		return name;
	}
	
	public static Colour convert(String str){
		for(Colour c : values()){
			if(c.toString().equals(str)){
				return c;
			}
		}
		return NONE;
	}
	
	public Colour join(Colour c){
		if(this==NONE || c==NONE){
			return NONE;
		}
		if(this==PANDA || c==PANDA){
			return PANDA;
		}
		if(this==c){
			return c;
		}
		if(this==GREY){
			return c;
		}
		if(c==GREY){
			return this;
		}
				
		return PANDA;
	}
	
	
	public static Colour analyze(Content content){
		Colour ret=Colour.GREY;
		//Agentׂ
		switch(content.getTopic()){
		case AGREE://ȗ
		case DISAGREE:
			break;
		case ESTIMATE://lOEۂŕނ
			if(content.getRole().getSpecies()==Species.WEREWOLF){
				ret=Colour.BLACK;
			}
			else{
				ret=Colour.WHITE;
			}
			break;
		case GUARDED://q͔̂
		case ATTACK://Û͔
			ret=Colour.WHITE;
			break;
		case VOTE://[͍̂
			ret=Colour.BLACK;
			break;
		default:
			break;
		
		}
		
		
		return ret;
	}
	
	
}
