package jp.ac.shibaura_it.ma15082;

import java.util.ArrayList;
import java.util.List;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;


public class LineInfo {
	public static WasabiAnalyzer wa;
	private JudgeInfo si;
	private JudgeInfo mi;
	private double score;
	private ListMap<Agent,Double> clist;
	
	
	public LineInfo(JudgeInfo seer,JudgeInfo medium,List<PlayerInfo> pis,int s_num,int m_num){
		si=seer;
		mi=medium;
		clist=new ListMap<Agent,Double>(16);
		score=-1;
		init(pis,s_num,m_num);
	}
	
	
	
	public void init(List<PlayerInfo> plist,int s_num,int m_num){
		List<Agent> greylist=new ArrayList<Agent>();
		score=-1;
		int seer_liar=0;
		int medium_liar=0;
		int max_black=0;
		int min_black=0;
		int black_num=0;
		int black_liar=0;
		int white_liar=0;
		int black_dead=0;
		int bitten_liar=0;
		double seer_certain=0;
		double medium_certain=0;
		int temp;
		
		black_liar=(wa.getRoleNum(Role.WEREWOLF));
		white_liar=(wa.getRoleNum(Role.POSSESSED));

		
		seer_liar=wa.seerSize()-wa.getRoleNum(Role.SEER)-1;
		medium_liar=wa.mediumSize()-wa.getRoleNum(Role.MEDIUM)-1;
		

		
		for(PlayerInfo pi : plist){
			Colour cm=Colour.GREY;
			Colour cs=Colour.GREY;
			Colour cd=Colour.GREY;
			Colour c=Colour.GREY;
			
			if(pi.getRole().equals(Role.SEER)){
				if(si==null){
					clist.put(pi.getAgent(),seer_certain);
					//c=Colour.NONE;
					continue;
				}
				else if(pi.getAgent().equals(si.getAgent())){
					clist.put(pi.getAgent(),1.0);
					c=Colour.WHITE;
				}
				else{
					clist.put(pi.getAgent(),seer_certain);
					if(pi.isBitten()){
						bitten_liar++;
					}
					else if(pi.isVoted()){
						if(mi!=null && mi.getColour(pi.getAgent())==Colour.WHITE){
							bitten_liar++;
						}
					}
					else if(si!=null && si.getColour(pi.getAgent())==Colour.WHITE){
						bitten_liar++;
					}
					//c=Colour.NONE;
					continue;
				}
				//continue;
			}
			else if(pi.getRole().equals(Role.MEDIUM)){
				if(mi==null){
					clist.put(pi.getAgent(),medium_certain);
					//c=Colour.NONE;
					continue;
				}
				else if(pi.getAgent().equals(mi.getAgent())){
					clist.put(pi.getAgent(),1.0);
					c=Colour.WHITE;
				}
				else{
					clist.put(pi.getAgent(),medium_certain);
					if(pi.isBitten()){
						bitten_liar++;
					}
					else if(pi.isVoted()){
						if(mi!=null && mi.getColour(pi.getAgent())==Colour.WHITE){
							bitten_liar++;
						}
					}
					else if(si!=null && si.getColour(pi.getAgent())==Colour.WHITE){
						bitten_liar++;
					}
					//c=Colour.NONE;
					continue;
				}
				//continue;
			}
			
			//else if(pi.getRole().equals(Role.FREEMASON)){
			//	clist.put(pi.getAgent(),1.0);
			//	c=Colour.WHITE;
			//}
			
			
			if(mi!=null){
				cm=mi.getColour(pi.getAgent());
			}
			if(si!=null){
				cs=si.getColour(pi.getAgent());
			}
			if(pi.isBitten()){
				cd=Colour.WHITE;
			}
			
			
			c=c.join(cs);
			c=c.join(cm);
			c=c.join(cd);
			switch(c){
			case GREY:
				greylist.add(pi.getAgent());
				break;
			case WHITE:
				clist.put(pi.getAgent(),1.0);
				break;
			case BLACK:
				clist.put(pi.getAgent(),0.0);
				black_num++;
				if(pi.isDead()){
					black_dead++;
				}
				break;
			default:
				clist.put(pi.getAgent(),0.0);
				score=0;
				break;
				
			}
			
			
		}
		
		temp=(seer_liar+medium_liar)-white_liar;
		
		if(temp < 0){
			max_black=black_liar-black_num;
		}
		else{
			max_black=black_liar-temp-black_num;
		}

		temp=(seer_liar+medium_liar);
		if(temp < 0){
			min_black=black_liar-black_num;
		}
		else{
			min_black=black_liar-temp-black_num;
		}

		if(max_black<0){
			score=0;
		}
		else if(min_black > greylist.size()){
			score=0;
		}
		else if(bitten_liar>white_liar){
			score=0;
		}
		else if(si!=null && si.tooMany()){
			score=0;
		}
		else if(mi!=null && (wa.getAliveSize()-1)/2 < (wa.getRoleNum(Role.WEREWOLF)-mi.blackNum()-wa.getDay()+mi.size())){
			score=0;
		}
		else if(black_dead>=wa.getRoleNum(Role.WEREWOLF)){
			score=0;
		}
		
		
		
		
		
		if(score==0.0){
			for(Agent s : greylist){
				clist.put(s,0.0);
			}
			return;
		}

				
		
		
		
		score=1.0/(bitten_liar+1.0);
		//ĂƂ͐Mx
		//NOTE:
		//班傫߂ɐݒ肷
		if(mi==null){
			score*=3.0/wa.getPlayerNum();
			//score*=1.0/wa.getPlayerNum();
		}
		if(si==null){
			score*=1.5/wa.getPlayerNum();
			//score*=1.0/wa.getPlayerNum();
		}
		
		
		double point=(double)(greylist.size()-max_black)/greylist.size();
		if(point<0){
			point=0;
		}

		for(Agent s : greylist){
			clist.put(s,point);
		}
		
		
		return;
		
	}
	
	public double getScore()
	{
		return score;
	}
	
	public ListMap<Agent,Double> getScoreList(){
		return clist;
	}
	
	public JudgeInfo getSeer(){
		return si;
	}

	public JudgeInfo getMedium(){
		return mi;
	}
	
	
}
