package jp.ac.shibaura_it.ma15082.player;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.aiwolf.client.lib.Content;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Player;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;
import org.aiwolf.common.data.Team;
import org.aiwolf.common.data.Vote;
import org.aiwolf.common.net.GameInfo;
import org.aiwolf.common.net.GameSetting;

import jp.ac.shibaura_it.ma15082.JudgeInfo;
import jp.ac.shibaura_it.ma15082.LineInfo;
import jp.ac.shibaura_it.ma15082.ListMap;
import jp.ac.shibaura_it.ma15082.Pair;
import jp.ac.shibaura_it.ma15082.Personality;
import jp.ac.shibaura_it.ma15082.PersonalityFactory;
import jp.ac.shibaura_it.ma15082.PlayerInfo;
import jp.ac.shibaura_it.ma15082.TalkInfo;
import jp.ac.shibaura_it.ma15082.Tools;
import jp.ac.shibaura_it.ma15082.WasabiAnalyzer;


public class WasabiPlayer implements Player{

	private String name;
	private Agent agent;
	private GameInfo gi;
	private Personality personality;
	private TalkFactory talk_factory;
	
	//̉
	private WasabiAnalyzer wa;
	//_̏
	private List<PlayerInfo> view;
	//ϓIȐMx
	private ListMap<Agent,Double> score;
	private ListMap<ListMap<Agent,Double>,Double> scores;
	
	//TEl̃Xg
	private ListMap<Agent,Pair<Role,Double>> wolfs;
	private List<Agent> lunatics;
	//xE
	private Role myRole;

	private List<String> role_mess;
	private int skip_count;
	private double th;
	
	boolean hiddenflag;
	private Agent vote_target;
	private Agent attack_target;
	
	//NX^
	final int v_num=4;
	final int d_num=4;
	final int a_num=4;
	final int g_num=3;
	private ListMap<Role,ListMap<Personality,Team>> datamap=null;
	
	public Agent getAgent(){
		return agent;
	}
	public Role getRole(){
		return gi.getRole();
	}
	public Personality getPersonality(){
		return personality;
	}
	public void setDataMap(ListMap<Role,ListMap<Personality,Team>> map){
		datamap=map;
	}
	public ListMap<Role,ListMap<Personality,Team>> getDataMap(){
		return datamap;
	}
	public int getWinNum(){
		int sum=0;
		for(int i=0;i<datamap.size();i++){
			Role role=datamap.getKey(i);
			List<Team> teams=datamap.getValue(i).valueList();
			for(Team t : teams){
				if(role.getTeam()==t){
					sum++;
				}
			}
		}
		return sum;
	}
	
	public int getGameNum(){
		int sum=0;
		for(int i=0;i<datamap.size();i++){
			sum+=datamap.getValue(i).size();
		}
		return sum;
	}
	public int getGameNum(Role role){
		return datamap.get(role).size();
	}
	public int getWinNum(Role role){
		int sum=0;
		List<Team> teams=datamap.get(role).valueList();
		for(Team t : teams){
			if(role.getTeam()==t){
				sum++;
			}
		}
		return sum;
	}
	
	@Override
	public void initialize(GameInfo arg0, GameSetting arg1) {
		gi=arg0;
		agent=gi.getAgent();
		name="WASABI_"+agent.getAgentIdx();
		view=new ArrayList<PlayerInfo>(16);;
		score=new ListMap<Agent,Double>(16);
		scores=new ListMap<ListMap<Agent,Double>,Double>();
		
		talk_factory=TalkFactory.getInstance();
		
		if(datamap==null){
			datamap=new ListMap<Role,ListMap<Personality,Team>>();
			for(Role r : Role.values()){
				datamap.put(r,new ListMap<Personality,Team>());
			}
		}
		
		
		

		personality=PersonalityFactory.getPersonality(gi.getRole());
		/*
		if(agent.getAgentIdx()==1){
			personality=PersonalityFactory.getPersonality(gi.getRole());
			//personality=PersonalityFactory.getLearnedPersonality(gi.getRole(),datamap);
		}
		else{
			personality=PersonalityFactory.getRandomPersonality();
		}*/
	
		
		
		wolfs=new ListMap<Agent,Pair<Role,Double>>();
		lunatics=new ArrayList<Agent>();

		wa=new WasabiAnalyzer(arg0,arg1);
		LineInfo.wa=wa;
		role_mess=new ArrayList<String>();
		
		//NOTE:x̌vZ͂łȂ
		//TxȂ狶lx
		if(gi.getRole()==Role.WEREWOLF){
			for(Agent a : gi.getAgentList()){
				if(gi.getRoleMap().get(a)==Role.WEREWOLF){
					wolfs.put(a,null);
				}
			}
		}
		else if(gi.getRole()==Role.POSSESSED){
			myRole=Role.SEER;
		}
		th=0;
		vote_target=null;
		attack_target=null;
		hiddenflag=true;
		return;
	}

	
	

	@Override
	public void update(GameInfo arg0) {
		gi=arg0;
		wa.update(gi);
		view.clear();
		scores.clear();
		for(PlayerInfo p : wa.getPlayerInfos()){
			PlayerInfo pi=new PlayerInfo(p);
			view.add(pi);
			pi.setCertain(0.0);
			if(pi.getAgent().equals(agent)){
				score.put(pi.getAgent(),1.0);//͐΂ɔ
			}
			
			else{
				score.put(pi.getAgent(), Tools.random()*personality.getWeightRandom()+(1-personality.getWeightRandom())*wa.getScore(agent,pi.getAgent(),gi.getDay()));//ϓIȋ^
			}
		}
		
		for(LineInfo li : wa.getLineInfos()){
			ListMap<Agent,Double> lm=li.getScoreList();
			scores.add(lm, li.getScore() * lm.get(agent));
		}
		Tools.unit(scores);
		int count=0;
		th=0;
		for(PlayerInfo pi : view){
			Agent p=pi.getAgent();
			double p_score=score.get(p);
			for(int i=0;i<scores.size();++i){
				double t_score =scores.getKey(i).get(p);
				pi.setCertain(pi.getCertain()+scores.getValue(i)*calcCertain(t_score,p_score,personality.getWeightSubjective()));
			}
			if(pi.isAlive() && !agent.equals(pi.getAgent())){
				th+=pi.getCertain();
				count++;
			}
		}
		if(count>0){
			th/=count;
		}
		
		
		for(PlayerInfo pi : view){
			if(pi.getRole().getTeam()==Team.WEREWOLF){
				pi.setCertain(0);
			}
		}

		//System.err.println(wa.getAliveSize()+" "+wa.getAlivePlayerInfo().size());
		return;
	}
	

	final private static double calcCertain(double a,double b,double r){
		double f=3*r*a*(1-a);
		return (f*b+(1-f)*a);
	}


	//NOTE:mess,role_messdayStartŐݒ
	//role_mess͂ǂCO,ʂ2
	//0ڂ͂ȂɂȂ
	//1ڂKCO
	@Override
	public void dayStart() {
		Judge j;
		if(gi.getDay()<=0){
			//mess=getTalkList();
			return;
		}
		role_mess.clear();
		switch(gi.getRole()){
		case SEER:
			j=gi.getDivineResult();
			if(hiddenflag){
				role_mess.add(talk_factory.comingout(agent,Role.SEER).getText());
				hiddenflag=false;
			}
			if(j!=null){
				role_mess.add(talk_factory.divined(j.getTarget(),j.getResult()).getText());
			}
			break;
		case MEDIUM:
			j=gi.getMediumResult();
			if(hiddenflag){
				role_mess.add(talk_factory.comingout(agent,Role.MEDIUM).getText());
				hiddenflag=false;
			}
			if(j!=null){
				role_mess.add(talk_factory.inquested(j.getTarget(),j.getResult()).getText());
			}
			break;
		case POSSESSED:
			if(myRole==Role.SEER){
				wolf_divine();
			}
			break;
		case WEREWOLF:
			break;
		default:
			break;
			
		}
		
		skip_count=0;
		vote_target=null;
		attack_target=null;
	}	
	
	@Override
	public void finish() {
		if(datamap!=null && datamap.get(gi.getRole())!=null){
			Map<Agent,Role> map=gi.getRoleMap();
			boolean vwin=true;
			for(Agent a : gi.getAliveAgentList()){
				if(map.get(a).getSpecies()==Species.WEREWOLF){
					vwin=false;
					break;
				}
			}
			datamap.get(gi.getRole()).add( personality, vwin?Team.VILLAGER:Team.WEREWOLF);
		}
	}
	
	@Override
	public String getName() {
		return name;
	}
	
	@Override
	public Agent vote() {
		List<Vote> latest=wa.getLatestVoteList();
		//ē[
		if(latest!=null && latest.size()>0){
			List<Pair<Agent,Agent>> list=new ArrayList<Pair<Agent,Agent>>();
			
			int[] v_counter=new int[wa.getPlayerNum()+1];
			for(Vote v : latest){
				list.add(new Pair<Agent,Agent>(v.getAgent(),v.getTarget()));
				int index=v.getTarget().getAgentIdx();
				v_counter[index]++;	
			}
			
			int min=Integer.MAX_VALUE;
			int max=-1;
			for(Vote v : latest){
				int index=v.getTarget().getAgentIdx();
				if(v_counter[index]<min){
					min=v_counter[index];
				}
				if(v_counter[index]>max){
					max=v_counter[index];
				}
			}
			wa.getTalkInfo().setVoteMessages(list);
			
			//System.err.println("vote"+latest);
			ListMap<Agent,Double> votelist=getVoteList();
			int counter=v_counter[vote_target.getAgentIdx()];
			//System.err.println(agent+" "+min+" "+max+" "+counter);
			//[悪ő哾[̂Ƃ͕KςȂ
			if((max-min)>1 && min<counter && max<=counter){
				//System.err.println(agent+" "+vote_target);
				return vote_target;
			}
			//[悪ŏ[̂Ƃ͕Kς
			if(counter<=min || counter<max){
				votelist.put(vote_target, 0.0);
			}
			Agent p=Tools.selectKey(votelist);
			if(p!=null){
				//System.err.println(agent+" "+vote_target+" "+p);
				//System.err.flush();
				vote_target=p;
			}
			
			return vote_target;
		}
		
		if(vote_target!=null){
						
			return vote_target;
		}
		ListMap<Agent,Double> votelist=getVoteList();
		vote_target=Tools.selectKey(votelist);
		if(vote_target==null){
			vote_target=getOne(false);
		}
		
		return vote_target;
	}


	//NOTE:CӂŎ̂Ȃo
	//4l̂Ƃ͎̂Ȃɂ
	//5l̂Ƃɓ[ňlޏꂷ邩cl5lŎ̂Ȃ
	@Override
	public Agent attack() {
		List<Vote> latest=wa.getLatestAttackVoteList();
		//ē[
		if(latest!=null && latest.size()>0){
			List<Pair<Agent,Agent>> list=new ArrayList<Pair<Agent,Agent>>();
			
			int[] v_counter=new int[wa.getPlayerNum()+1];
			for(Vote v : latest){
				list.add(new Pair<Agent,Agent>(v.getAgent(),v.getTarget()));
				int index=v.getTarget().getAgentIdx();
				v_counter[index]++;	
			}
			
			int min=Integer.MAX_VALUE;
			int max=-1;
			for(Vote v : latest){
				int index=v.getTarget().getAgentIdx();
				if(v_counter[index]<min){
					min=v_counter[index];
				}
				if(v_counter[index]>max){
					max=v_counter[index];
				}
			}
			wa.getTalkInfo().setAttackMessages(list);
			
			ListMap<Agent,Double> attacklist=getAttackList();
			int counter=v_counter[attack_target.getAgentIdx()];
			//[悪ő[̂Ƃ͕KςȂ
			if((max-min)>1 && min<counter && max<=counter){
				return attack_target;
			}
			//[悪ŏ[̂Ƃ͕Kς
			if(counter<=min || ((max-min)>1 && counter<max)){
				attacklist.put(attack_target, 0.0);
			}
			Agent p=Tools.selectKey(attacklist);
			if(p!=null){
				attack_target=p;
			}
			
			return attack_target;
		}
		if(attack_target!=null){
			return attack_target;
		}
		/*
		if(gi.getAliveAgentList().size()==5){
			return null;
		}*/
		ListMap<Agent,Double> attacklist=getAttackList();
		attack_target=Tools.selectKey(attacklist);
		if(attack_target==null){
			attack_target=getOne(true);
		}
		return attack_target;
	}

	@Override
	public Agent divine() {
		ListMap<Agent,Double> divinelist=getDivineList();
		Agent p=Tools.selectKey(divinelist);
		if(p==null){
			p=getOne(false);
		}
		return p;
	}

	@Override
	public Agent guard() {
		ListMap<Agent,Double> guardlist=getGuardList();
		Agent p=Tools.selectKey(guardlist);
		if(p==null){
			p=getOne(false);
		}
		return p;
	}


	//NOTE:bZ[WgetTalkLstł܂Ƃ߂Ď擾getTalkŖ擾
	//talk11bZ[WMłȂAupdatẻelł
	@Override
	public String talk() {
		if(role_mess!=null && role_mess.size()>0){
			return role_mess.remove(0);
		}
		return getTalk();
	}

	@Override
	public String whisper() {
		return getWhisper();
	}

	
	//NOTE:EbnŖ̂`FbN
	public void searchLunatics(){
		lunatics.clear();
		for(JudgeInfo ji : wa.getSeerInfos()){
			for(Judge j : ji.getJudgeList()){
				if(wolfs.containsKey(j.getTarget())){
					if(j.getResult()==Species.HUMAN){
						lunatics.add(ji.getAgent());
						break;
					}
				}
				else{
					if(j.getResult()==Species.WEREWOLF){
						lunatics.add(ji.getAgent());
						break;
					}
				}
			}
		}
		for(JudgeInfo ji : wa.getMediumInfos()){
			for(Judge j : ji.getJudgeList()){
				if(wolfs.containsKey(j.getTarget())){
					if(j.getResult()==Species.HUMAN){
						lunatics.add(ji.getAgent());
						break;
					}
				}
				else{
					if(j.getResult()==Species.WEREWOLF){
						lunatics.add(ji.getAgent());
						break;
					}
				}
			}
		}
		return;
	}

	public void wolf_divine(){
		ListMap<Agent,Double> divinelist=getDivineList();
		Agent p=Tools.selectKey(divinelist);
		if(p==null){
			List<Agent> as=gi.getAliveAgentList();
			while(p==null){
				p=as.get(Tools.rand(as.size()));
				if(p==agent){
					p=null;
				}
			}
		}
		double a=0;
		PlayerInfo temp=null;
		for(PlayerInfo pi : view){
			if(pi.getAgent().equals(p)){
				a=pi.getCertain();
				temp=pi;
				break;
			}
		}
		//_̐Mx猋ʂ߂
		Species c=Species.HUMAN;
		if(temp.getRole()!=Role.VILLAGER){
			JudgeInfo j=wa.getSeerInfo(agent);
			if(j!=null){
				int d=j.blackNum();
				c=(d>=3?Species.HUMAN:Species.WEREWOLF);
			}
			else{
				c=Species.WEREWOLF;
			}
		}
		else{
			c=((Tools.random())<a) ? Species.HUMAN:Species.WEREWOLF;
		}
		//System.err.println(p+" "+a+" "+c);
		if(hiddenflag){
			role_mess.add(talk_factory.comingout(agent,Role.SEER).getText());
			hiddenflag=false;
		}
		role_mess.add(talk_factory.divined(p,c).getText());
		return;
	}
	

	private Agent getOne(boolean flag){
		List<Agent> list=gi.getAliveAgentList();
		list.remove(agent);
		if(flag){
			for(Agent a : wolfs.keySet()){
				list.remove(a);
			}
		}
		return list.get(Tools.rand(list.size()));
	}

	public ListMap<Agent,Double> getAliveList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				ret.add(pi.getAgent(), 1.0);
			}
			else{
				ret.add(pi.getAgent(), 0.0);
			}
		}
		return ret;
	}

	//true->white false->black
	public ListMap<Agent,Double> getAliveList(boolean flag){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean nonzero=false;
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				double x=(flag?pi.getCertain():1.0-pi.getCertain());
				if(x>0){
					nonzero=true;
				}
				ret.add(pi.getAgent(),x);
			} else {
				ret.add(pi.getAgent(),0.0);
			}
		}

		if(nonzero){
			return ret;
		}
		return getAliveList();
	}


	
	public ListMap<Agent,Double> getVoteList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean flag;
		TalkInfo ti=wa.getTalkInfo();
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				double v=1.0+ti.getVotePoint(pi.getAgent(),wa.getAliveSize())*personality.getWeightAlong();
				double x=1.0-pi.getCertain();
				//^킵ȂlTɂ͓[Ȃ
				if(wolfs.keyList().contains(pi.getAgent()) && pi.getCertain()>th){
					ret.add(pi.getAgent(),0.0);
				}
				
				//c̐lƂɂ͐肢t͂ɂ
				else if(pi.getRole()==Role.SEER){
					
					double th=1.0/gi.getAliveAgentList().size();
					double a=((double)(wa.seerSize()-1.0)/gi.getAliveAgentList().size());
					double r=1.0-pi.getCertain();
					
					if(gi.getRole()==Role.SEER || myRole==Role.SEER){
						x=r*a;
						if(x>1.0){
							x=1.0;
						}
					}
					else{
						if(r<th || (1-th)<r){
							x=r;
						}
						else{
							x=r*a;
							if(x>1.0){
								x=1.0;
							}
						}
					}
					
					
				}
				
				
				double m=x*v;
				if(m<0){
					ret.add(pi.getAgent(), m);
				}
				else{
					ret.add(pi.getAgent(),m);
				}
				
			}
			
			else{
				ret.add(pi.getAgent(),0.0);				
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,v_num,1);
		
		if(flag){
			return ret;
		}
		ret=getAliveList(false);
		ret.put(agent,0.0);
		return ret;
	}
	




	public ListMap<Agent,Double> getAttackList(){
		searchLunatics();
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		TalkInfo ti=wa.getTalkInfo();
		boolean flag;
		for(PlayerInfo pi : view){
			if(wolfs.containsKey(pi.getAgent())){
				ret.add(pi.getAgent(),0.0);
			}
			else if(pi.isAlive()){
				double v=1.0+(ti.getAttackPoint(pi.getAgent(),wa.getAliveSize())-ti.getVotePoint(pi.getAgent(), wa.getAliveSize()))*personality.getWeightAlong();
				double x;
				
				if(pi.getRole()==Role.SEER){
					x=pi.getCertain()*2;
				}
				else{
					x=pi.getCertain();
				}
				double m=x*v;
				if(m<0){
					ret.add(pi.getAgent(),0.0);
				}
				else{
					ret.add(pi.getAgent(),m);
				}
			}			
			else{
				ret.add(pi.getAgent(),0.0);				
			}
		}
		for(Agent s : lunatics){
			ret.put(s, 0.0);
		}
		flag=Tools.cutList(ret,a_num,1);
		if(flag){
			return ret;
		}
		ret=getAliveList(true);
		for(Agent s : lunatics){
			ret.put(s, 0.0);
		}
		for(Agent s : wolfs.keyList()){
			ret.put(s,0.0);
		}
		return ret;
	}

	public ListMap<Agent,Double> getGuardList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean flag;
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				
				double a=0.1;
				if(pi.getRole()==Role.SEER){
					a*=wa.getAliveSize()/2.0;
				}
				else if(pi.getRole()==Role.MEDIUM){
					a*=2;
				}
				TalkInfo ti=wa.getTalkInfo();
				
				double x=pi.getCertain()*a;
				double v=1.0-ti.getVotePoint(pi.getAgent(), wa.getAliveSize())*personality.getWeightAlong();
				double m=x*v;
				if(m<0){
					ret.add(pi.getAgent(),0.0);
				}
				else{
					ret.add(pi.getAgent(),m);
				}
				
			}
			else{
				ret.add(pi.getAgent(),0.0);
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,g_num,1);
		if(flag){
			return ret;
		}
		ret=getAliveList(true);
		ret.put(agent,0.0);
		return ret;
	}

	public ListMap<Agent,Double> getDivineList(){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		boolean flag=false;
		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				if(pi.isChecked()){
					ret.add(pi.getAgent(),0.0);
				}
				else if(pi.getRole()==Role.MEDIUM || pi.getRole()==Role.SEER){
					ret.add(pi.getAgent(),0.0);
				}
				else{
					TalkInfo ti=wa.getTalkInfo();
					double x=pi.getCertain()*(1-pi.getCertain());
					double v=1.0-ti.getVotePoint(pi.getAgent(), wa.getAliveSize())*personality.getWeightAlong();
					double m=x*v;
					if(m<0){
						ret.add(pi.getAgent(),0.0);
					}
					else{
						ret.add(pi.getAgent(),m);
					}
				}
				
			}
			else{
				ret.add(pi.getAgent(),0.0);
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret, d_num, 1);
		if(flag){
			return ret;
		}


		for(PlayerInfo pi : view){
			if(pi.isAlive()){
				if(pi.isChecked(agent)){
					ret.put(pi.getAgent(),0.0);
				}
				else if(pi.getRole()==Role.MEDIUM || pi.getRole()==Role.SEER){
					ret.put(pi.getAgent(),0.0);
				}
				else{
					double x=pi.getCertain()*(1-pi.getCertain());
					ret.put(pi.getAgent(),x);
				}

			}
			else{
				ret.put(pi.getAgent(),0.0);
			}

		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,3,1);
		if(flag){
			return ret;
		}

		ret=getAliveList(false);
		for(PlayerInfo pi : view){
			if(pi.isChecked(agent)){
				ret.put(pi.getAgent(), 0.0);
			}
		}
		ret.put(agent,0.0);
		flag=Tools.cutList(ret,2,1);
		if(flag){
			return ret;
		}

		ret=getAliveList();
		ret.put(agent,0.0);
		return ret;
	}



	public ListMap<Agent,Double> getWhiteList(double th){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		for(PlayerInfo pi : view){
			if(pi.isDead()){
				ret.add(pi.getAgent(),0.0);
			}
			else if(pi.getAgent().equals(agent)){
				ret.add(pi.getAgent(),0.0);
			}
			else if(th<pi.getCertain()){
				ret.add(pi.getAgent(),pi.getCertain());
			}
			else{
				ret.add(pi.getAgent(), 0.0);
			}
		}
		return ret;
	}


	public ListMap<Agent,Double> getBlackList(double th){
		ListMap<Agent,Double> ret=new ListMap<Agent,Double>();
		for(PlayerInfo pi : view){
			if(pi.isDead()){
				ret.add(pi.getAgent(),0.0);
			}
			else if(pi.getAgent().equals(agent)){
				ret.add(pi.getAgent(),0.0);
			}
			else if(pi.getCertain()<th){
				ret.add(pi.getAgent(),1-pi.getCertain());
			}
			else{
				ret.add(pi.getAgent(), 0.0);
			}
		}

		return ret;
	}

	
	//NOTE:̖͂EA͘TłƐ锭
	public String getTalk(){
		Content ret=skip_count>2?talk_factory.over():talk_factory.skip();
		Agent to;
		Role role;
		if(personality.getWeightVolume()<Tools.random(-0.2,1.0)){
			skip_count++;
			return ret.getText();
		}
		ListMap<Agent,Double> map=getVoteList();
		if(vote_target==null){
			vote_target=Tools.selectKey(map);			
			if(vote_target!=null){
				return talk_factory.vote(vote_target).getText();
			}
		}
		else{
			if(map.get(vote_target)<=0 || Tools.random()<personality.getWeightRandom()){
				Agent temp=Tools.selectKey(map);
				if(temp!=null && vote_target!=temp){
					vote_target=temp;
					return talk_factory.vote(vote_target).getText();
				}
			}
		}
		
		if(Tools.random()<personality.getWeightTalkWhite()){
			to=Tools.selectKey(getWhiteList(th));
			role=Role.VILLAGER;
			for(PlayerInfo pi : view){
				if(pi.getAgent().equals(to)){
					role=pi.getRole();
					break;
				}
			}
		}
		else{
			to=Tools.selectKey(getBlackList(th));
			role=Role.WEREWOLF;
		}
		if(to!=null){
			ret=(talk_factory.estimate(to,role));
		}
		
		return ret.getText();
	}
	
	public String getWhisper(){
		//NOTE:ǂȍs邩Al̈ʒuɂĘb
		Agent p;
		Content ret=talk_factory.over();
		if(personality.getWeightVolume()<Tools.random(-0.2,1.0)){
			return ret.getText();
		}
		
		ListMap<Agent,Double> map=getAttackList();
		if(attack_target==null){
			attack_target=Tools.selectKey(map);
			if(attack_target!=null){
				return talk_factory.attack(attack_target).getText();
			}
		}
		else{
			if(map.get(attack_target)<=0 || Tools.random()<personality.getWeightRandom()){
				p=Tools.selectKey(map);
				if(p!=null && attack_target!=p){
					attack_target=p;
					return talk_factory.attack(attack_target).getText();
				}
			}
		}
		
		
		switch(Tools.rand(5)){
		case 0://lɂ
		if(lunatics.size()>0){
			ret=talk_factory.estimate(lunatics.get(Tools.rand(lunatics.size())), Role.POSSESSED);
		}
		break;
		/*
		case 1://[ɂ
			p=Tools.selectKey(getVoteList());
			if(p!=null){
				ret=factory.vote(p);
			}
			break;
		case 2://肢ɂ
			p=Tools.selectKey(getDivineList());
			if(p!=null){
				Species s=wolfs.containsKey(p)?Species.WEREWOLF:Species.HUMAN;
				ret=factory.divined(p,s);
			}
			break;
		case 3://qɂ
			p=Tools.selectKey(getGuardList());
			if(p!=null){
				ret=factory.guarded(p);
			}
			break;
			
		case 4://Pɂ
			ListMap<Agent,Double> map1=getAttackList();
			if(attack_target==null){
				attack_target=Tools.selectKey(map1);
				if(attack_target!=null){
					ret=factory.attack(attack_target);
				}
			}
			else{
				if(map1.get(attack_target)<=0 || Tools.random()<personality.getWeightRandom()){
					p=Tools.selectKey(map1);
					if(p!=null && attack_target!=p){
						attack_target=p;
						ret=factory.attack(p);
					}
				}
			}
			break;
			*/
		default:
			break;
		}
		return ret.getText();
	}
	
}

